/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSVRDisplay.h"

#include "ActiveDOMObject.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertCallbacks.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include "JSRequestAnimationFrameCallback.h"
#include "JSVRDisplayCapabilities.h"
#include "JSVREye.h"
#include "JSVREyeParameters.h"
#include "JSVRFrameData.h"
#include "JSVRLayerInit.h"
#include "JSVRPose.h"
#include "JSVRStageParameters.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetEyeParameters(JSC::JSGlobalObject*, JSC::CallFrame*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetFrameData(JSC::JSGlobalObject*, JSC::CallFrame*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetPose(JSC::JSGlobalObject*, JSC::CallFrame*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionResetPose(JSC::JSGlobalObject*, JSC::CallFrame*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionRequestAnimationFrame(JSC::JSGlobalObject*, JSC::CallFrame*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionCancelAnimationFrame(JSC::JSGlobalObject*, JSC::CallFrame*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionRequestPresent(JSC::JSGlobalObject*, JSC::CallFrame*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionExitPresent(JSC::JSGlobalObject*, JSC::CallFrame*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetLayers(JSC::JSGlobalObject*, JSC::CallFrame*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionSubmitFrame(JSC::JSGlobalObject*, JSC::CallFrame*);

// Attributes

JSC::EncodedJSValue jsVRDisplayConstructor(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSVRDisplayConstructor(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsVRDisplayIsConnected(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayIsPresenting(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayCapabilities(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayStageParameters(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayDisplayId(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayDisplayName(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayDepthNear(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSVRDisplayDepthNear(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsVRDisplayDepthFar(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSVRDisplayDepthFar(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSVRDisplayPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSVRDisplayPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSVRDisplayPrototype* ptr = new (NotNull, JSC::allocateCell<JSVRDisplayPrototype>(vm.heap)) JSVRDisplayPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSVRDisplayPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSVRDisplayConstructor = JSDOMConstructorNotConstructable<JSVRDisplay>;

template<> JSValue JSVRDisplayConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSEventTarget::getConstructor(vm, &globalObject);
}

template<> void JSVRDisplayConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSVRDisplay::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(vm, String("VRDisplay"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSVRDisplayConstructor::s_info = { "VRDisplay", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRDisplayConstructor) };

/* Hash table for prototype */

static const HashTableValue JSVRDisplayPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSVRDisplayConstructor) } },
    { "isConnected", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayIsConnected), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "isPresenting", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayIsPresenting), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "capabilities", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayCapabilities), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "stageParameters", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayStageParameters), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "displayId", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayDisplayId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "displayName", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayDisplayName), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "depthNear", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayDepthNear), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSVRDisplayDepthNear) } },
    { "depthFar", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayDepthFar), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSVRDisplayDepthFar) } },
    { "getEyeParameters", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionGetEyeParameters), (intptr_t) (1) } },
    { "getFrameData", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionGetFrameData), (intptr_t) (1) } },
    { "getPose", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionGetPose), (intptr_t) (0) } },
    { "resetPose", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionResetPose), (intptr_t) (0) } },
    { "requestAnimationFrame", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionRequestAnimationFrame), (intptr_t) (1) } },
    { "cancelAnimationFrame", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionCancelAnimationFrame), (intptr_t) (1) } },
    { "requestPresent", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionRequestPresent), (intptr_t) (1) } },
    { "exitPresent", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionExitPresent), (intptr_t) (0) } },
    { "getLayers", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionGetLayers), (intptr_t) (0) } },
    { "submitFrame", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionSubmitFrame), (intptr_t) (0) } },
};

const ClassInfo JSVRDisplayPrototype::s_info = { "VRDisplayPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRDisplayPrototype) };

void JSVRDisplayPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSVRDisplay::info(), JSVRDisplayPrototypeTableValues, *this);
}

const ClassInfo JSVRDisplay::s_info = { "VRDisplay", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRDisplay) };

JSVRDisplay::JSVRDisplay(Structure* structure, JSDOMGlobalObject& globalObject, Ref<VRDisplay>&& impl)
    : JSEventTarget(structure, globalObject, WTFMove(impl))
{
}

void JSVRDisplay::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(std::is_base_of<ActiveDOMObject, VRDisplay>::value, "Interface is marked as [ActiveDOMObject] but implementation class does not subclass ActiveDOMObject.");

}

JSObject* JSVRDisplay::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSVRDisplayPrototype::create(vm, &globalObject, JSVRDisplayPrototype::createStructure(vm, &globalObject, JSEventTarget::prototype(vm, globalObject)));
}

JSObject* JSVRDisplay::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSVRDisplay>(vm, globalObject);
}

JSValue JSVRDisplay::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSVRDisplayConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSVRDisplay* IDLAttribute<JSVRDisplay>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSVRDisplay*>(JSC::getVM(&lexicalGlobalObject), JSValue::decode(thisValue));
}

template<> inline JSVRDisplay* IDLOperation<JSVRDisplay>::cast(JSGlobalObject& lexicalGlobalObject, CallFrame& callFrame)
{
    return jsDynamicCast<JSVRDisplay*>(JSC::getVM(&lexicalGlobalObject), callFrame.thisValue());
}

EncodedJSValue jsVRDisplayConstructor(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVRDisplayPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSVRDisplay::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

bool setJSVRDisplayConstructor(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVRDisplayPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(lexicalGlobalObject, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsVRDisplayIsConnectedGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.isConnected());
    return result;
}

EncodedJSValue jsVRDisplayIsConnected(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayIsConnectedGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "isConnected");
}

static inline JSValue jsVRDisplayIsPresentingGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.isPresenting());
    return result;
}

EncodedJSValue jsVRDisplayIsPresenting(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayIsPresentingGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "isPresenting");
}

static inline JSValue jsVRDisplayCapabilitiesGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<VRDisplayCapabilities>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.capabilities());
    return result;
}

EncodedJSValue jsVRDisplayCapabilities(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayCapabilitiesGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "capabilities");
}

static inline JSValue jsVRDisplayStageParametersGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLInterface<VRStageParameters>>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.stageParameters());
    return result;
}

EncodedJSValue jsVRDisplayStageParameters(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayStageParametersGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "stageParameters");
}

static inline JSValue jsVRDisplayDisplayIdGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.displayId());
    return result;
}

EncodedJSValue jsVRDisplayDisplayId(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayDisplayIdGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "displayId");
}

static inline JSValue jsVRDisplayDisplayNameGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(lexicalGlobalObject, throwScope, impl.displayName());
    return result;
}

EncodedJSValue jsVRDisplayDisplayName(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayDisplayNameGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "displayName");
}

static inline JSValue jsVRDisplayDepthNearGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.depthNear());
    return result;
}

EncodedJSValue jsVRDisplayDepthNear(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayDepthNearGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "depthNear");
}

static inline bool setJSVRDisplayDepthNearSetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplay& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(lexicalGlobalObject);
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setDepthNear(WTFMove(nativeValue));
    });
    return true;
}

bool setJSVRDisplayDepthNear(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSVRDisplay>::set<setJSVRDisplayDepthNearSetter>(*lexicalGlobalObject, thisValue, encodedValue, "depthNear");
}

static inline JSValue jsVRDisplayDepthFarGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.depthFar());
    return result;
}

EncodedJSValue jsVRDisplayDepthFar(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayDepthFarGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "depthFar");
}

static inline bool setJSVRDisplayDepthFarSetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplay& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(lexicalGlobalObject);
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setDepthFar(WTFMove(nativeValue));
    });
    return true;
}

bool setJSVRDisplayDepthFar(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSVRDisplay>::set<setJSVRDisplayDepthFarSetter>(*lexicalGlobalObject, thisValue, encodedValue, "depthFar");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionGetEyeParametersBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(lexicalGlobalObject);
    UNUSED_PARAM(callFrame);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    auto whichEye = convert<IDLEnumeration<VREye>>(*lexicalGlobalObject, callFrame->uncheckedArgument(0), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentMustBeEnumError(lexicalGlobalObject, scope, 0, "whichEye", "VRDisplay", "getEyeParameters", expectedEnumerationValues<VREye>()); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLInterface<VREyeParameters>>(*lexicalGlobalObject, *castedThis->globalObject(), impl.getEyeParameters(WTFMove(whichEye))));
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetEyeParameters(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionGetEyeParametersBody>(*lexicalGlobalObject, *callFrame, "getEyeParameters");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionGetFrameDataBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(lexicalGlobalObject);
    UNUSED_PARAM(callFrame);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    auto frameData = convert<IDLInterface<VRFrameData>>(*lexicalGlobalObject, callFrame->uncheckedArgument(0), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentTypeError(lexicalGlobalObject, scope, 0, "frameData", "VRDisplay", "getFrameData", "VRFrameData"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLBoolean>(impl.getFrameData(*frameData)));
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetFrameData(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionGetFrameDataBody>(*lexicalGlobalObject, *callFrame, "getFrameData");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionGetPoseBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(lexicalGlobalObject);
    UNUSED_PARAM(callFrame);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJSNewlyCreated<IDLInterface<VRPose>>(*lexicalGlobalObject, *castedThis->globalObject(), impl.getPose()));
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetPose(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionGetPoseBody>(*lexicalGlobalObject, *callFrame, "getPose");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionResetPoseBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(lexicalGlobalObject);
    UNUSED_PARAM(callFrame);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.resetPose();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionResetPose(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionResetPoseBody>(*lexicalGlobalObject, *callFrame, "resetPose");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionRequestAnimationFrameBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(lexicalGlobalObject);
    UNUSED_PARAM(callFrame);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    auto callback = convert<IDLCallbackFunction<JSRequestAnimationFrameCallback>>(*lexicalGlobalObject, callFrame->uncheckedArgument(0), *castedThis->globalObject(), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentMustBeFunctionError(lexicalGlobalObject, scope, 0, "callback", "VRDisplay", "requestAnimationFrame"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLLong>(impl.requestAnimationFrame(callback.releaseNonNull())));
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionRequestAnimationFrame(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionRequestAnimationFrameBody>(*lexicalGlobalObject, *callFrame, "requestAnimationFrame");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionCancelAnimationFrameBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(lexicalGlobalObject);
    UNUSED_PARAM(callFrame);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    auto handle = convert<IDLUnsignedLong>(*lexicalGlobalObject, callFrame->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.cancelAnimationFrame(WTFMove(handle));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionCancelAnimationFrame(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionCancelAnimationFrameBody>(*lexicalGlobalObject, *callFrame, "cancelAnimationFrame");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionRequestPresentBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperationReturningPromise<JSVRDisplay>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(lexicalGlobalObject);
    UNUSED_PARAM(callFrame);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    auto layers = convert<IDLSequence<IDLDictionary<VRLayerInit>>>(*lexicalGlobalObject, callFrame->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.requestPresent(WTFMove(layers), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionRequestPresent(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    return IDLOperationReturningPromise<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionRequestPresentBody>(*lexicalGlobalObject, *callFrame, "requestPresent");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionExitPresentBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperationReturningPromise<JSVRDisplay>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(lexicalGlobalObject);
    UNUSED_PARAM(callFrame);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.exitPresent(WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionExitPresent(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    return IDLOperationReturningPromise<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionExitPresentBody>(*lexicalGlobalObject, *callFrame, "exitPresent");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionGetLayersBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(lexicalGlobalObject);
    UNUSED_PARAM(callFrame);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLSequence<IDLDictionary<VRLayerInit>>>(*lexicalGlobalObject, *castedThis->globalObject(), impl.getLayers()));
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetLayers(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionGetLayersBody>(*lexicalGlobalObject, *callFrame, "getLayers");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionSubmitFrameBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(lexicalGlobalObject);
    UNUSED_PARAM(callFrame);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.submitFrame();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionSubmitFrame(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionSubmitFrameBody>(*lexicalGlobalObject, *callFrame, "submitFrame");
}

void JSVRDisplay::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSVRDisplay*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSVRDisplayOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    auto* jsVRDisplay = jsCast<JSVRDisplay*>(handle.slot()->asCell());
    if (jsVRDisplay->wrapped().hasPendingActivity()) {
        if (UNLIKELY(reason))
            *reason = "ActiveDOMObject with pending activity";
        return true;
     }
    if (jsVRDisplay->wrapped().isFiringEventListeners()) {
        if (UNLIKELY(reason))
            *reason = "EventTarget firing event listeners";
        return true;
    }
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSVRDisplayOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsVRDisplay = static_cast<JSVRDisplay*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsVRDisplay->wrapped(), jsVRDisplay);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7VRDisplay@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore9VRDisplayE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<VRDisplay>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = WTF_PREPARE_VTBL_POINTER_FOR_INSPECTION(__identifier("??_7VRDisplay@WebCore@@6B@"));
#else
    void* expectedVTablePointer = WTF_PREPARE_VTBL_POINTER_FOR_INSPECTION(&_ZTVN7WebCore9VRDisplayE[2]);
#endif

    // If this fails VRDisplay does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<VRDisplay>::value, "VRDisplay is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // VRDisplay has subclasses. If VRDisplay has subclasses that get passed
    // to toJS() we currently require VRDisplay you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<VRDisplay>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, VRDisplay& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

VRDisplay* JSVRDisplay::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSVRDisplay*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
