/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSVRDisplayCapabilities.h"

#include "ActiveDOMObject.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

JSC::EncodedJSValue jsVRDisplayCapabilitiesConstructor(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSVRDisplayCapabilitiesConstructor(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsVRDisplayCapabilitiesHasPosition(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayCapabilitiesHasOrientation(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayCapabilitiesHasExternalDisplay(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayCapabilitiesCanPresent(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayCapabilitiesMaxLayers(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSVRDisplayCapabilitiesPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSVRDisplayCapabilitiesPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSVRDisplayCapabilitiesPrototype* ptr = new (NotNull, JSC::allocateCell<JSVRDisplayCapabilitiesPrototype>(vm.heap)) JSVRDisplayCapabilitiesPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSVRDisplayCapabilitiesPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSVRDisplayCapabilitiesConstructor = JSDOMConstructorNotConstructable<JSVRDisplayCapabilities>;

template<> JSValue JSVRDisplayCapabilitiesConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSVRDisplayCapabilitiesConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSVRDisplayCapabilities::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(vm, String("VRDisplayCapabilities"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSVRDisplayCapabilitiesConstructor::s_info = { "VRDisplayCapabilities", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRDisplayCapabilitiesConstructor) };

/* Hash table for prototype */

static const HashTableValue JSVRDisplayCapabilitiesPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayCapabilitiesConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSVRDisplayCapabilitiesConstructor) } },
    { "hasPosition", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayCapabilitiesHasPosition), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "hasOrientation", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayCapabilitiesHasOrientation), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "hasExternalDisplay", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayCapabilitiesHasExternalDisplay), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "canPresent", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayCapabilitiesCanPresent), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxLayers", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayCapabilitiesMaxLayers), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSVRDisplayCapabilitiesPrototype::s_info = { "VRDisplayCapabilitiesPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRDisplayCapabilitiesPrototype) };

void JSVRDisplayCapabilitiesPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSVRDisplayCapabilities::info(), JSVRDisplayCapabilitiesPrototypeTableValues, *this);
}

const ClassInfo JSVRDisplayCapabilities::s_info = { "VRDisplayCapabilities", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRDisplayCapabilities) };

JSVRDisplayCapabilities::JSVRDisplayCapabilities(Structure* structure, JSDOMGlobalObject& globalObject, Ref<VRDisplayCapabilities>&& impl)
    : JSDOMWrapper<VRDisplayCapabilities>(structure, globalObject, WTFMove(impl))
{
}

void JSVRDisplayCapabilities::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, VRDisplayCapabilities>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSVRDisplayCapabilities::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSVRDisplayCapabilitiesPrototype::create(vm, &globalObject, JSVRDisplayCapabilitiesPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSVRDisplayCapabilities::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSVRDisplayCapabilities>(vm, globalObject);
}

JSValue JSVRDisplayCapabilities::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSVRDisplayCapabilitiesConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSVRDisplayCapabilities::destroy(JSC::JSCell* cell)
{
    JSVRDisplayCapabilities* thisObject = static_cast<JSVRDisplayCapabilities*>(cell);
    thisObject->JSVRDisplayCapabilities::~JSVRDisplayCapabilities();
}

template<> inline JSVRDisplayCapabilities* IDLAttribute<JSVRDisplayCapabilities>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSVRDisplayCapabilities*>(JSC::getVM(&lexicalGlobalObject), JSValue::decode(thisValue));
}

EncodedJSValue jsVRDisplayCapabilitiesConstructor(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVRDisplayCapabilitiesPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSVRDisplayCapabilities::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

bool setJSVRDisplayCapabilitiesConstructor(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVRDisplayCapabilitiesPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(lexicalGlobalObject, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsVRDisplayCapabilitiesHasPositionGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplayCapabilities& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.hasPosition());
    return result;
}

EncodedJSValue jsVRDisplayCapabilitiesHasPosition(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplayCapabilities>::get<jsVRDisplayCapabilitiesHasPositionGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "hasPosition");
}

static inline JSValue jsVRDisplayCapabilitiesHasOrientationGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplayCapabilities& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.hasOrientation());
    return result;
}

EncodedJSValue jsVRDisplayCapabilitiesHasOrientation(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplayCapabilities>::get<jsVRDisplayCapabilitiesHasOrientationGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "hasOrientation");
}

static inline JSValue jsVRDisplayCapabilitiesHasExternalDisplayGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplayCapabilities& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.hasExternalDisplay());
    return result;
}

EncodedJSValue jsVRDisplayCapabilitiesHasExternalDisplay(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplayCapabilities>::get<jsVRDisplayCapabilitiesHasExternalDisplayGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "hasExternalDisplay");
}

static inline JSValue jsVRDisplayCapabilitiesCanPresentGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplayCapabilities& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.canPresent());
    return result;
}

EncodedJSValue jsVRDisplayCapabilitiesCanPresent(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplayCapabilities>::get<jsVRDisplayCapabilitiesCanPresentGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "canPresent");
}

static inline JSValue jsVRDisplayCapabilitiesMaxLayersGetter(JSGlobalObject& lexicalGlobalObject, JSVRDisplayCapabilities& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.maxLayers());
    return result;
}

EncodedJSValue jsVRDisplayCapabilitiesMaxLayers(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplayCapabilities>::get<jsVRDisplayCapabilitiesMaxLayersGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "maxLayers");
}

void JSVRDisplayCapabilities::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSVRDisplayCapabilities*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSVRDisplayCapabilitiesOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSVRDisplayCapabilitiesOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsVRDisplayCapabilities = static_cast<JSVRDisplayCapabilities*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsVRDisplayCapabilities->wrapped(), jsVRDisplayCapabilities);
}

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<VRDisplayCapabilities>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to VRDisplayCapabilities.
    static_assert(!std::is_polymorphic<VRDisplayCapabilities>::value, "VRDisplayCapabilities is polymorphic but the IDL claims it is not");
    return createWrapper<VRDisplayCapabilities>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, VRDisplayCapabilities& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

VRDisplayCapabilities* JSVRDisplayCapabilities::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSVRDisplayCapabilities*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
