/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSVREyeParameters.h"

#include "ActiveDOMObject.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMWrapperCache.h"
#include "JSVRFieldOfView.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

JSC::EncodedJSValue jsVREyeParametersConstructor(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSVREyeParametersConstructor(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsVREyeParametersOffset(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVREyeParametersFieldOfView(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVREyeParametersRenderWidth(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVREyeParametersRenderHeight(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSVREyeParametersPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSVREyeParametersPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSVREyeParametersPrototype* ptr = new (NotNull, JSC::allocateCell<JSVREyeParametersPrototype>(vm.heap)) JSVREyeParametersPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSVREyeParametersPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSVREyeParametersConstructor = JSDOMConstructorNotConstructable<JSVREyeParameters>;

template<> JSValue JSVREyeParametersConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSVREyeParametersConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSVREyeParameters::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(vm, String("VREyeParameters"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSVREyeParametersConstructor::s_info = { "VREyeParameters", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVREyeParametersConstructor) };

/* Hash table for prototype */

static const HashTableValue JSVREyeParametersPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVREyeParametersConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSVREyeParametersConstructor) } },
    { "offset", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVREyeParametersOffset), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "fieldOfView", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVREyeParametersFieldOfView), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "renderWidth", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVREyeParametersRenderWidth), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "renderHeight", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVREyeParametersRenderHeight), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSVREyeParametersPrototype::s_info = { "VREyeParametersPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVREyeParametersPrototype) };

void JSVREyeParametersPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSVREyeParameters::info(), JSVREyeParametersPrototypeTableValues, *this);
}

const ClassInfo JSVREyeParameters::s_info = { "VREyeParameters", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVREyeParameters) };

JSVREyeParameters::JSVREyeParameters(Structure* structure, JSDOMGlobalObject& globalObject, Ref<VREyeParameters>&& impl)
    : JSDOMWrapper<VREyeParameters>(structure, globalObject, WTFMove(impl))
{
}

void JSVREyeParameters::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, VREyeParameters>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSVREyeParameters::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSVREyeParametersPrototype::create(vm, &globalObject, JSVREyeParametersPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSVREyeParameters::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSVREyeParameters>(vm, globalObject);
}

JSValue JSVREyeParameters::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSVREyeParametersConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSVREyeParameters::destroy(JSC::JSCell* cell)
{
    JSVREyeParameters* thisObject = static_cast<JSVREyeParameters*>(cell);
    thisObject->JSVREyeParameters::~JSVREyeParameters();
}

template<> inline JSVREyeParameters* IDLAttribute<JSVREyeParameters>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSVREyeParameters*>(JSC::getVM(&lexicalGlobalObject), JSValue::decode(thisValue));
}

EncodedJSValue jsVREyeParametersConstructor(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVREyeParametersPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSVREyeParameters::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

bool setJSVREyeParametersConstructor(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVREyeParametersPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(lexicalGlobalObject, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsVREyeParametersOffsetGetter(JSGlobalObject& lexicalGlobalObject, JSVREyeParameters& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFloat32Array>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.offset());
    return result;
}

EncodedJSValue jsVREyeParametersOffset(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVREyeParameters>::get<jsVREyeParametersOffsetGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "offset");
}

static inline JSValue jsVREyeParametersFieldOfViewGetter(JSGlobalObject& lexicalGlobalObject, JSVREyeParameters& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<VRFieldOfView>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.fieldOfView());
    return result;
}

EncodedJSValue jsVREyeParametersFieldOfView(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVREyeParameters>::get<jsVREyeParametersFieldOfViewGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "fieldOfView");
}

static inline JSValue jsVREyeParametersRenderWidthGetter(JSGlobalObject& lexicalGlobalObject, JSVREyeParameters& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.renderWidth());
    return result;
}

EncodedJSValue jsVREyeParametersRenderWidth(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVREyeParameters>::get<jsVREyeParametersRenderWidthGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "renderWidth");
}

static inline JSValue jsVREyeParametersRenderHeightGetter(JSGlobalObject& lexicalGlobalObject, JSVREyeParameters& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, impl.renderHeight());
    return result;
}

EncodedJSValue jsVREyeParametersRenderHeight(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVREyeParameters>::get<jsVREyeParametersRenderHeightGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "renderHeight");
}

void JSVREyeParameters::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSVREyeParameters*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSVREyeParametersOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSVREyeParametersOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsVREyeParameters = static_cast<JSVREyeParameters*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsVREyeParameters->wrapped(), jsVREyeParameters);
}

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<VREyeParameters>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to VREyeParameters.
    static_assert(!std::is_polymorphic<VREyeParameters>::value, "VREyeParameters is polymorphic but the IDL claims it is not");
    return createWrapper<VREyeParameters>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, VREyeParameters& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

VREyeParameters* JSVREyeParameters::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSVREyeParameters*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
