/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSVRFrameData.h"

#include "ActiveDOMObject.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMWrapperCache.h"
#include "JSVRPose.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

JSC::EncodedJSValue jsVRFrameDataConstructor(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSVRFrameDataConstructor(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsVRFrameDataTimestamp(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRFrameDataLeftProjectionMatrix(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRFrameDataLeftViewMatrix(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRFrameDataRightProjectionMatrix(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRFrameDataRightViewMatrix(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRFrameDataPose(JSC::JSGlobalObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSVRFrameDataPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSVRFrameDataPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSVRFrameDataPrototype* ptr = new (NotNull, JSC::allocateCell<JSVRFrameDataPrototype>(vm.heap)) JSVRFrameDataPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSVRFrameDataPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSVRFrameDataConstructor = JSDOMConstructor<JSVRFrameData>;

template<> EncodedJSValue JSC_HOST_CALL JSVRFrameDataConstructor::construct(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    VM& vm = lexicalGlobalObject->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSVRFrameDataConstructor*>(callFrame->jsCallee());
    ASSERT(castedThis);
    auto object = VRFrameData::create();
    return JSValue::encode(toJSNewlyCreated<IDLInterface<VRFrameData>>(*lexicalGlobalObject, *castedThis->globalObject(), WTFMove(object)));
}

template<> JSValue JSVRFrameDataConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSVRFrameDataConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSVRFrameData::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(vm, String("VRFrameData"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSVRFrameDataConstructor::s_info = { "VRFrameData", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRFrameDataConstructor) };

/* Hash table for prototype */

static const HashTableValue JSVRFrameDataPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRFrameDataConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSVRFrameDataConstructor) } },
    { "timestamp", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRFrameDataTimestamp), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "leftProjectionMatrix", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRFrameDataLeftProjectionMatrix), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "leftViewMatrix", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRFrameDataLeftViewMatrix), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "rightProjectionMatrix", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRFrameDataRightProjectionMatrix), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "rightViewMatrix", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRFrameDataRightViewMatrix), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "pose", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRFrameDataPose), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSVRFrameDataPrototype::s_info = { "VRFrameDataPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRFrameDataPrototype) };

void JSVRFrameDataPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSVRFrameData::info(), JSVRFrameDataPrototypeTableValues, *this);
}

const ClassInfo JSVRFrameData::s_info = { "VRFrameData", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRFrameData) };

JSVRFrameData::JSVRFrameData(Structure* structure, JSDOMGlobalObject& globalObject, Ref<VRFrameData>&& impl)
    : JSDOMWrapper<VRFrameData>(structure, globalObject, WTFMove(impl))
{
}

void JSVRFrameData::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, VRFrameData>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSVRFrameData::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSVRFrameDataPrototype::create(vm, &globalObject, JSVRFrameDataPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSVRFrameData::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSVRFrameData>(vm, globalObject);
}

JSValue JSVRFrameData::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSVRFrameDataConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSVRFrameData::destroy(JSC::JSCell* cell)
{
    JSVRFrameData* thisObject = static_cast<JSVRFrameData*>(cell);
    thisObject->JSVRFrameData::~JSVRFrameData();
}

template<> inline JSVRFrameData* IDLAttribute<JSVRFrameData>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSVRFrameData*>(JSC::getVM(&lexicalGlobalObject), JSValue::decode(thisValue));
}

EncodedJSValue jsVRFrameDataConstructor(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVRFrameDataPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSVRFrameData::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

bool setJSVRFrameDataConstructor(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVRFrameDataPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(lexicalGlobalObject, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsVRFrameDataTimestampGetter(JSGlobalObject& lexicalGlobalObject, JSVRFrameData& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.timestamp());
    return result;
}

EncodedJSValue jsVRFrameDataTimestamp(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRFrameData>::get<jsVRFrameDataTimestampGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "timestamp");
}

static inline JSValue jsVRFrameDataLeftProjectionMatrixGetter(JSGlobalObject& lexicalGlobalObject, JSVRFrameData& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFloat32Array>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.leftProjectionMatrix());
    return result;
}

EncodedJSValue jsVRFrameDataLeftProjectionMatrix(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRFrameData>::get<jsVRFrameDataLeftProjectionMatrixGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "leftProjectionMatrix");
}

static inline JSValue jsVRFrameDataLeftViewMatrixGetter(JSGlobalObject& lexicalGlobalObject, JSVRFrameData& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFloat32Array>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.leftViewMatrix());
    return result;
}

EncodedJSValue jsVRFrameDataLeftViewMatrix(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRFrameData>::get<jsVRFrameDataLeftViewMatrixGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "leftViewMatrix");
}

static inline JSValue jsVRFrameDataRightProjectionMatrixGetter(JSGlobalObject& lexicalGlobalObject, JSVRFrameData& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFloat32Array>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.rightProjectionMatrix());
    return result;
}

EncodedJSValue jsVRFrameDataRightProjectionMatrix(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRFrameData>::get<jsVRFrameDataRightProjectionMatrixGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "rightProjectionMatrix");
}

static inline JSValue jsVRFrameDataRightViewMatrixGetter(JSGlobalObject& lexicalGlobalObject, JSVRFrameData& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFloat32Array>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.rightViewMatrix());
    return result;
}

EncodedJSValue jsVRFrameDataRightViewMatrix(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRFrameData>::get<jsVRFrameDataRightViewMatrixGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "rightViewMatrix");
}

static inline JSValue jsVRFrameDataPoseGetter(JSGlobalObject& lexicalGlobalObject, JSVRFrameData& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<VRPose>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.pose());
    return result;
}

EncodedJSValue jsVRFrameDataPose(JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRFrameData>::get<jsVRFrameDataPoseGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "pose");
}

void JSVRFrameData::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSVRFrameData*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSVRFrameDataOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSVRFrameDataOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsVRFrameData = static_cast<JSVRFrameData*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsVRFrameData->wrapped(), jsVRFrameData);
}

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<VRFrameData>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to VRFrameData.
    static_assert(!std::is_polymorphic<VRFrameData>::value, "VRFrameData is polymorphic but the IDL claims it is not");
    return createWrapper<VRFrameData>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, VRFrameData& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

VRFrameData* JSVRFrameData::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSVRFrameData*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
