/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSVRLayerInit.h"

#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMGlobalObject.h"
#include "JSHTMLCanvasElement.h"
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

template<> VRLayerInit convertDictionary<VRLayerInit>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    VRLayerInit result;
    JSValue leftBoundsValue;
    if (isNullOrUndefined)
        leftBoundsValue = jsUndefined();
    else {
        leftBoundsValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "leftBounds"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!leftBoundsValue.isUndefined()) {
        result.leftBounds = convert<IDLSequence<IDLFloat>>(lexicalGlobalObject, leftBoundsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.leftBounds = Converter<IDLSequence<IDLFloat>>::ReturnType{ };
    JSValue rightBoundsValue;
    if (isNullOrUndefined)
        rightBoundsValue = jsUndefined();
    else {
        rightBoundsValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "rightBounds"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!rightBoundsValue.isUndefined()) {
        result.rightBounds = convert<IDLSequence<IDLFloat>>(lexicalGlobalObject, rightBoundsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.rightBounds = Converter<IDLSequence<IDLFloat>>::ReturnType{ };
    JSValue sourceValue;
    if (isNullOrUndefined)
        sourceValue = jsUndefined();
    else {
        sourceValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "source"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!sourceValue.isUndefined()) {
        result.source = convert<IDLNullable<IDLInterface<HTMLCanvasElement>>>(lexicalGlobalObject, sourceValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.source = nullptr;
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject& lexicalGlobalObject, JSDOMGlobalObject& globalObject, const VRLayerInit& dictionary)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);

    auto result = constructEmptyObject(&lexicalGlobalObject, globalObject.objectPrototype());

    auto leftBoundsValue = toJS<IDLSequence<IDLFloat>>(lexicalGlobalObject, globalObject, dictionary.leftBounds);
    result->putDirect(vm, JSC::Identifier::fromString(vm, "leftBounds"), leftBoundsValue);
    auto rightBoundsValue = toJS<IDLSequence<IDLFloat>>(lexicalGlobalObject, globalObject, dictionary.rightBounds);
    result->putDirect(vm, JSC::Identifier::fromString(vm, "rightBounds"), rightBoundsValue);
    auto sourceValue = toJS<IDLNullable<IDLInterface<HTMLCanvasElement>>>(lexicalGlobalObject, globalObject, dictionary.source);
    result->putDirect(vm, JSC::Identifier::fromString(vm, "source"), sourceValue);
    return result;
}

} // namespace WebCore
